//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "charmap.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCharmap *Charmap;

int TCharmapResult;
int SavedKey;
//---------------------------------------------------------------------------
__fastcall TCharmap::TCharmap(TComponent* Owner)
        : TForm(Owner)
{
    // Write all available fonts to SelectedFont ComboBox
    for (int i = 0; i < Screen->Fonts->Count; i++)
        SelectedFont->Items->Add(Screen->Fonts->Strings[i]);

    // Write characters 32 to 255 into CharGrid
    for (int x = 0; x < 32; x++) for (int y = 0; y < 7; y++)
        CharGrid->Cells[x][y] = AnsiString(char(byte(x+32*(y+1))));

    // Use Times New Roman as standard font
    SelectedFont->ItemIndex = SelectedFont->Items->IndexOf("Times New Roman");
    SelectedFontChange(this);

    // Clear results from former calls
    BtnClearClick(this);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCharmap::Execute()
{
    // NOTE: If you use TCharmap as a dialog window, please call this
    // function to run the dialog and wait for its result, which is an
    // AnsiString representing all characters chosen from the char map.

    BtnClearClick(this);
    SelectedFont->ItemIndex = SelectedFont->Items->IndexOf("Times New Roman");
    SelectedFontChange(this);

    // Wait for exit click
    ShowModal();

    return SelectionAll->Text;
}
//---------------------------------------------------------------------------
void __fastcall TCharmap::SelectedFontChange(TObject *Sender)
{
    // Another font was selected
    CharGrid->Font->Name = SelectedFont->Items->Strings[SelectedFont->ItemIndex];
    SelectedCharacter->Font->Name = SelectedFont->Items->Strings[SelectedFont->ItemIndex];
    SelectionAll->Font->Name = SelectedFont->Items->Strings[SelectedFont->ItemIndex];
}
//---------------------------------------------------------------------------
void __fastcall TCharmap::SelectCharacter(int Which)
{
    // Show selected character
    SelectedCharacter->Caption = AnsiString(char(byte(Which)));

    // Show alternative key code
    AnsiString ShortKeyNumber = AnsiString(Which);
    while (ShortKeyNumber.Length() < 4) ShortKeyNumber = "0" + ShortKeyNumber;

    // Determine if key code is valid and save key
    if (Which == 0) SelectedCharacterID->Caption = "( None )";
               else SelectedCharacterID->Caption = "( ALT + " + ShortKeyNumber + " )";
    SavedKey = Which;
}
//---------------------------------------------------------------------------
void __fastcall TCharmap::CharGridSelectCell(TObject *Sender, int ACol, int ARow, bool &CanSelect)
{
    // Select character from grid
    SelectCharacter(ACol + 32*(ARow+1));
}
//---------------------------------------------------------------------------
void __fastcall TCharmap::BtnClearClick(TObject *Sender)
{
    // Reset All
    SelectCharacter(0);
    TGridRect Rect;
    Rect.Left = -1;
    Rect.Top = -1;
    Rect.Right = -1;
    Rect.Bottom = -1;
    CharGrid->Selection = Rect;
    SelectCharacter(0);
    SelectionAll->Text = "";
}
//---------------------------------------------------------------------------
void __fastcall TCharmap::BtnExitClick(TObject *Sender)
{
    // Exit. If the char map was started as a dialog, Close()
    // will go back to Execute().
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TCharmap::BtnAddClick(TObject *Sender)
{
    // Copy currently selected character to SelectionAll label
    if (SavedKey > 0)
        SelectionAll->Text = SelectionAll->Text + char(SavedKey);
}
//---------------------------------------------------------------------------
void __fastcall TCharmap::BtnCopyClick(TObject *Sender)
{
    // If any characters were selected, copy selection to Clipboard
    if (SelectionAll->Text.Length() > 0)
    {
        // Note: Only selected characters are copied, so select the
        // complete text first !
        SelectionAll->SelectAll();
        SelectionAll->CopyToClipboard();
    }
}
//---------------------------------------------------------------------------

